<?php
/**
 * @file Delfiweb.class.php 
 * @desc Cette classe permet de renvoyer les informations ncessaires au flash via AMFPHP
 *
 * @update : -
 *
 * @author Matthieu DELOISON
 * @date 07 Janvier 2006 
 * @update 
 *
 * @version 1
 
 
 CREATE TABLE `tel_package` (
  `ID` int(11) NOT NULL auto_increment,
  `compteur` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `compteur` (`compteur`),
) TYPE=MyISAM;

INSERT INTO `tel_package` ( `ID` , `compteur` )
VALUES (
NULL , '0'
);


 */
 
 
/**
 * @detail : 
 * 		- permet le fonctionnement du site Delfiweb.
 *
 * @usage :
 * 		- fonctionne avec AMFPHP
 *		- renseigner toutes les mthodes accessibles au flash dans le constructeur de la classe
 * 
 *
 * http://localhost/delfiweb.com/include/php/amfphp/services/Delfiweb.php
 */


/**
 * @note : 
 * 		- bien scuriser les requtes MySQL de cette option car ils des INSERT dans la BDD. Faire en sorte d'viter un flood de la BDD.
 *
 */
class Delfiweb
{

	private $oSqlConnection;
	

	
	// ---------------------------------------- __construct() ----------------------------------------------------
	/**
	 * @brief Constructeur de la classe. Initialise les proprits.
	 * @param (string) le nom de domaine  couter
	 * @param (integer) le port  couter
	 *
	 */
	public function __construct()
	{
		// permet de rcuprer le contenu d'une page du flash en fonction du bouton du menu choisi
		/* ajout de toutes les mthodes permettant le lancement de classes externes pour les diffrents projets */
		$this->methodTable = array
		(
			"getVisitCount" => array
			(
				"description" => "",
				"access" => "remote",
				"arguments" => "",
				"returns" => "array"
			),	
			
			"getContentPage" => array
			(
				"description" => "",
				"access" => "remote",
				"arguments" => "array",
				"returns" => "array"
			)
					
		);
				
		//$s_homeDirectory = "/home.2/delfiweb/www/v2/"; // PROD
		
		/* init */
		$s_homeDirectory = "../../../../"; // TEST
		require_once ($s_homeDirectory."include/php/classes/Master.php");
		$o_Master = Master::GetInstance();
		$o_Master->newPage($s_homeDirectory);
		
		$this->oSqlConnection = new Mysql();
	}



	// -----------------------------------------------------------------------------------------------------------
	// ---------------------------------------- Mthodes publiques -----------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	
	
	
	// ---------------------------------------- getVisitCount() ----------------------------------------------------	
	/**
	 * @brief Rcupre le nombre de visiteur sur le site actuellement, met  jour le compteur galement.
	 * @param -
	 * @return -
	 */	
	public function getVisitCount()
	{
		/* init des variables */
		$n_nbVisiteur = 0;	
		$n_nbVisiteurToday = 0;
		$n_nbVisiteurNow = 0;
		
		//on recupere l adresse ip du visiteur
		if($_SERVER) 	
		{
			if($_SERVER['HTTP_X_FORWARDED_FOR'])
				$sIpAdress = $_SERVER['HTTP_X_FORWARDED_FOR'];
			elseif($_SERVER['HTTP_CLIENT_IP'])
				$sIpAdress = $_SERVER['HTTP_CLIENT_IP'];
			else
				$sIpAdress = $_SERVER['REMOTE_ADDR'];
		}
		else 		
		{
			if(getenv('HTTP_X_FORWARDED_FOR'))
				$sIpAdress = getenv('HTTP_X_FORWARDED_FOR');
			elseif(getenv('HTTP_CLIENT_IP'))
				$sIpAdress = getenv('HTTP_CLIENT_IP');
			else
				$sIpAdress = getenv('REMOTE_ADDR');
		}
		
		
			
		$sDate = date("Y-m-d");
		//on convertit l heure courante en minute d une journee
		$sTime = (date("H") * 60) + date("i");
		
		//Debugger::GetInstance()->addlog("getContent : ".$s_urlXml);
		$s_sqlSelect = "SELECT compteur, date, time, duree FROM compteur_visite WHERE ip = 'compteur' LIMIT 1";
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		$o_result = $this->oSqlConnection->getObject($o_sqlResult);
		$n_nbVisiteur = $o_result->compteur;
		
		$iTimeConnexionRef = $o_result->time; //temps de connexion de reference
		$iDurationRef = $o_result->duree; //duree de renouvellement de reference
		$sDateBDD = $o_result->date; 		

		//on test si on a chang de jour
		if ( $sDate!=$sDateBDD )		
		{
			$s_sqlDelete = "DELETE FROM compteur_visite WHERE ip!='compteur'";//on vide toutes les addresses ip enregistres dans la table lors du changement de jour
			$o_sqlResult = $this->oSqlConnection->query($s_sqlDelete);
			$s_sqlUpdate = "UPDATE compteur_visite SET date='$sDate'";//on met a jour la nouvelle date dans la table
			$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
		}
		

		//on verifie l adresse ip du visiteur et aussi son heure de passage
		$s_sqlSelect = "SELECT compteur, date, time, duree FROM compteur_visite WHERE ip='$sIpAdress' LIMIT 1";
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		$o_result = $this->oSqlConnection->getObject($o_sqlResult);

		if( $o_result->compteur == NULL)
		{
			//on enregistre l adresse ip si elle est inconnu et on incremente le compteur
			$s_sqlInsert = "INSERT INTO compteur_visite (ip,time,duree) VALUES ('$sIpAdress','$sTime','$sTime')";
			$o_sqlResult = $this->oSqlConnection->query($s_sqlInsert);
			$n_nbVisiteur +=1;
			$s_sqlUpdate = "UPDATE compteur_visite SET compteur=$n_nbVisiteur WHERE ip='compteur' LIMIT 1";
			$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
		}
		else
		{
			//si l'adresse ip est connu alors verifie si sa connexion precedente est superieur a la dure
			//de renouvellement et si son heure de passage precedente incremente ou pas les connects
			$sTimeVisit = $o_result->time;//on recupere l'heure de sa precedente connexion de notre connect
			$sDurationVisit = $o_result->duree;//on recupere l'heure de sa precedente connexion de notre connect
			
			// on verifie si sa derniere connexion ne date pas de plus que la duree de reference
			if( $iDurationRef*60 < ( $sTime - ($sDurationVisit) ) )
			{
				//si la duree de reference est depass alors notre connect est comptablis 
				//comme nouvelle visite et on met a jour sa nouvelle heure de passage
				$s_sqlUpdate = "UPDATE compteur_visite SET time=$sTime, duree=$sTime WHERE ip='$sIpAdress' LIMIT 1";
				$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
				
				//on cree une ligne fictive pour pouvoir le comptabiliser dans les connects de jour
				$sIpAdressV = $sIpAdress.".".$n_nbVisiteur;
				//echo"sIpAdressV : ".$sIpAdressV;
				
				$s_sqlInsert ="INSERT INTO compteur_visite (ip,time,duree) VALUES ('$sIpAdressV','$sTime','$sTime')";
				$o_sqlResult = $this->oSqlConnection->query($s_sqlInsert);
				
				//et on increment le compteur de visite
				$n_nbVisiteur +=1;
				$s_sqlUpdate = "UPDATE compteur_visite SET compteur=$n_nbVisiteur WHERE ip='compteur' LIMIT 1";
				$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
			}
			else
			{
				//on met a jour son heure de passage si elle est superieure a t
				if ( $sTime > ( ($sTimeVisit)-$iTimeConnexionRef ) )
				{
					$s_sqlUpdate="UPDATE compteur_visite SET time=$sTime WHERE ip='$sIpAdress' LIMIT 1";
					$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
				}
			}
		
			
		}
		
		
		//on compte le nb de connect de la journe
		$s_sqlSelect = "SELECT ip FROM compteur_visite WHERE ip!='compteur'";
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		$n_nbVisiteurToday = $this->oSqlConnection->getNumRows();
		
		//on compte le nb de connect
		$sTimeToday = $sTime - $iTimeConnexionRef;
		$s_sqlSelect = "SELECT ip FROM compteur_visite WHERE time >= $sTimeToday AND ip!='compteur' ";
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		$n_nbVisiteurNow = $this->oSqlConnection->getNumRows();
			
			
		$aResult = array();
		$aResult["total"] = $n_nbVisiteur;	
		$aResult["today"] = $n_nbVisiteurToday;
		$aResult["now"] = $n_nbVisiteurNow;		
		return $aResult;
		
		
	}
	
		
	// ---------------------------------------- getContentPage() ----------------------------------------------------	
	/**
	 * @brief get dynamic content of web page
	 * @param -
	 * @return -
	 */		
	 public function getContentPage($aPage)
	 {
	 
	 	/*Debugger::GetInstance()->addlog("getContent name : ".$aPage["name"]);
		Debugger::GetInstance()->addlog("getContent balises : ".$aPage["balises"]);
		*/
		
		/* init var */
		$a_result = array();
		
		switch($aPage["name"])
		{			
			case "framework" :
						$s_sqlSelect = "SELECT compteur FROM tel_package WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##package_delfiweb##"] = $n_nbDownload;
						
						break;
			
			case "accueil" :
						$s_sqlSelect = "SELECT compteur FROM tel_package WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##package_delfiweb##"] = $n_nbDownload;
						
						break;	
							
			case "projets" :
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_SITE_AJAX WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##site_ajax##"] = $n_nbDownload;
						
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_ICON WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##icon_flash8##"] = $n_nbDownload;
						
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_EDITEUR WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##editeur##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_GALERIE WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##galeriephoto##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_RSS WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##lecteurrss##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_SITE WHERE id=1 LIMIT 1";$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##siteflash##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_FMAIL WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##form_mail##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_PRELOADER WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##preloader##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_CV WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##cvflash8##"] = $n_nbDownload;
						
						$s_sqlSelect = "SELECT compteur FROM CTP_TEL_LIVREDOR WHERE id=1 LIMIT 1";
						$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
						$o_result = $this->oSqlConnection->getObject($o_sqlResult);
						$n_nbDownload = $o_result->compteur;
						$a_result["##guestbook##"] = $n_nbDownload;
						break;
			default :	
		
				return $a_result;
		}
		

		return $a_result;
	 }
	 
	

	// -----------------------------------------------------------------------------------------------------------
	// ---------------------------------------- Mthodes prives -------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------




	// -----------------------------------------------------------------------------------------------------------
	// ---------------------------------------- Divers -----------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------


 	/**
	* @brief Destructeur de la classe
	* Utilis pour enregistrer des messages pour le debogage, fermer les fichier ouverts en criture ou en lecture, raliser des oprations
	* de nettoyage des objets utiliss...
	*
	* @param 
	* @return 
	*/
	public function __destruct() 
	{
 
 	}
	
	
	
	// ---------------------------------------- __toString() ----------------------------------------------------	
	/**
	 * @brief Dtermine comment la classe doit ragir lorsqu'elle est convertie en chane de caractres.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la reprsentation de l'objet sous forme de chane.
	 */	
	public function __toString() 
	{
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les proprits de la classe et les renvoie	
		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}
}

?>