<?php 

/**
 * @file Reference.class.php
 * @desc Cette classe permet de rfrencer delfiweb.
 * 
 * @author Matthieu DELOISON
 * @date Creation 02 Fvrier 2007
 * @update
 *
 *
 * @version 0.1 
 */
 

/**
 * @note : 
 *		- 
 *
 */

 
 /**
 * @details : 
 * 		- 
 *
 *
 * @usage :
 *		- $a_xmlTxt = array("xml/content/fr/accueil.xml", "xml/content/fr/news.xml");
		  $o_reference = new Reference($a_xmlTxt);
		  $o_reference->createFileHTML("include/page_content/contentXML.htm");
 *
 */
class Reference 
{
	/* caractrisitiques des chemins */
	private $a_XmlFile; 				// all file axml to be read

	
	
	
	// ---------------------------------- __construct() ----------------------------------------------------------
   /**
	* @brief Constructeur de la classe.
	* @param -
	*/
	public function __construct($a_XmlF)
	{
		$this->a_XmlFile = (array) $a_XmlF;
		
	}


	// -----------------------------------------------------------------------------------------------------------
	// -------------------------------------- Mthodes publiques  ------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	
	
	// ---------------------------------- createFileHTML() ----------------------------------------------------------
	/**
	* @brief Create the HTML file with the content of all xml file
	* @param (string) the path and the name of the file
	* @return (boolean) true if is good else false
	*/
	public function createFileHTML($s_FileName)
	{
		/* init var */
		$s_documentXML = "";
		
		foreach($this->a_XmlFile as $key=> $value)
		{
			$s_fileUrl = $value;
			
			/* test la validit du fichier xml */
			libxml_clear_errors(); // vide le buffer d'erreur libxml
			
			//$o_SimpleXMLelementFlash = @simplexml_load_string($s_fileUrl, 'SimpleXMLElement'); // cre un objet SimpleXMLElement
			$o_SimpleXMLelementFlash = @simplexml_load_file($s_fileUrl);
			
			
			$o_LibXMLError = libxml_get_last_error(); // Lit la dernire erreur libxml concernant l'analyse de l'objet SimpleXMLElement
			// si il y a une erreur dans le noeud xml
			if( !empty($o_LibXMLError ) )
			{
				$s_message = $o_LibXMLError->message; // rcupre le texte d'erreur
				libxml_clear_errors(); // vide le buffer d'erreur libxml
				echo " <br />- This xml file is incorrect : <br />".$s_message;
				return false;
			}
			
			/* rcupre le contenu du noeud description */
			foreach( $o_SimpleXMLelementFlash->page_content as $item )
			{
				$s_title = $item->title;
				$s_description = $item->description;				
			}
			
			$s_documentXML .= "<h1>".$s_title."</h1>".$s_description."<br /><br />";
			
			$a_xml 	= array("\n", "\r", "&");
			$a_html = array("<br />", "<br />", "&amp;");
			$s_documentXML = str_replace($a_xml, $a_html, $s_documentXML);
		}
		
		
		/* write the text in an html file */
		$handle = fopen($s_FileName, "w+"); 
		$i_nb_octet = fwrite($handle, $s_documentXML ); // criture dans le fichier
		
		if( $i_nb_octet===FALSE )
		{
			echo " <br />- Error occured during the writing of xml file.";
			return false;
		}
		
		// sinon criture russi, on ferme le fichier
		fclose($handle);
		return true;
	}


	
 	// -------------------------------------------------------------------------------------------------
	// ---------------------------------------- Divers  ------------------------------------------------
	// -------------------------------------------------------------------------------------------------

	
 	/**
	* @brief Destructeur de la classe
	* Utilis pour enregistrer des messages pour le debogage, fermer les fichier ouverts en criture ou en lecture, raliser des oprations
	* de nettoyage des objets utiliss...
	*
	* @param 
	* @return 
	*/
	public function __destruct() 
	{
 
 	}



	/**
	 * @brief Dtermine comment la classe doit ragir lorsqu'elle est convertie en chane de caractres.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la reprsentation de l'objet sous forme de chane.
	 */	
	public function __toString() 
	{
		
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les proprits de la classe et les renvoie	
		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}

}
 
 
 

?>