<?php
/**
 * @file Save.php 
 * @desc Cette classe permet de sayvegarder la base de données MySQL. Envoie par mail du fichier gzip optionnel.
 *
 * @update : -
 *
 * @author Matthieu DELOISON
 * @date 07 Janvier 2006 
 * @update 
 *
 * @version 1
 */
 
 

/**
 * @note : 
 * 		
 *
 */
class Save
{

	private $oSqlConnection;
	private $oFile;

	
	// ---------------------------------------- __construct() ----------------------------------------------------
	/**
	 * @brief Constructeur de la classe. Initialise les propriétés.
	 * @param (string) le nom de domaine à écouter
	 * @param (integer) le port à écouter
	 *
	 */
	public function __construct()
	{
		$this->oSqlConnection = new Mysql();
	}



	// -----------------------------------------------------------------------------------------------------------
	// ---------------------------------------- Méthodes publiques -----------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	
	
	
	// ---------------------------------------- saveBDD() ----------------------------------------------------	
	/**
	 * @brief save all database
	 * @param -
	 * @return -
	 */	
	public function esportDatabase()
	{
		/* database access */
		$aConfig = $this->oSqlConnection->getConfig();
		$ip			= $aConfig['ip'];
		$login			= $aConfig['login'];
		$password		= $aConfig['password'];
		$database		= $aConfig['database'];
		
		/* config */
		$s_siteName = "Delfiweb Ressources Flash";
		$s_siteUrl = "http://www.delfiweb.com/";
		//$s_mail = "antoine.labonne@laposte.net";
		$s_mail = "matthieu@delfiweb.com";


		$backup_email = stripslashes($s_mail);
		$backup = array();
		$backup['date'] = date("d-m-Y__H-i-s");  
		$backup['mysqldumppath'] = "/usr/bin/mysqldump";
		$backup['mysqlpath'] = "/usr/bin/mysql";
		$backup['path'] = "/homez.19/delfiweb/www/other";
		$backup['command'] = '';

		$backup['filename'] = $backup['date'].'_-_'.$database.'.sql.gz';
		$backup['filepath'] = $backup['path'].'/'.$backup['filename'];
		$backup['command'] = $backup['mysqldumppath'].' --host="'.$ip.'" --user="'.$login.'" --password="'.$password.'" --add-drop-table --skip-lock-tables '.$database.' | gzip > '.$backup['filepath'];
		
		// execute command UNIX
		passthru($backup['command'], $error);
		if ($error!=0) echo "Une erreur est survenue : ".$error."<br />";

		// Get And Read The Database Backup File
		$file_path = $backup['filepath'];
		$file_size = $this->format_size(filesize($file_path));
		$file_date = $backup['date'];
		$file = fopen($file_path,'rb');
		$file_data = fread($file,filesize($file_path));
		fclose($file);
		$file_data = chunk_split(base64_encode($file_data));
		
		// Create Mail To, Mail Subject And Mail Header
		$mail_subject = "Sauvegarde de la base de données du site 'Les Jeunes CAPS'";
		$mail_header = 'From: '.$s_siteName.' Administrateur <'.$s_mail.'>';
		// MIME Boundary
		$random_time = md5(time());
		$mime_boundary = "==DatabaseSave- $random_time";
		// Create Mail Header And Mail Message
		$mail_header .= "\nMIME-Version: 1.0\n" .
								"Content-Type: multipart/mixed;\n" .
								" boundary=\"{$mime_boundary}\"";
		$mail_message = "Website Name: ".$s_siteName."\n".
								"Website URL : ".$s_siteUrl."\n".
								"Backup File Name : ".$backup['filename']."\n".
								"Backup File Date : ".$file_date."\n".
								"Backup File Size : ".$file_size."\n\n".
								$s_siteName."\n".
								$s_siteUrl;
		$mail_message = "This is a multi-part message in MIME format.\n\n" .
								"--{$mime_boundary}\n" .
								"Content-Type: text/plain; charset=\"utf-8\"\n" .
								"Content-Transfer-Encoding: 7bit\n\n".$mail_message."\n\n";				
		$mail_message .= "--{$mime_boundary}\n" .
								"Content-Type: application/octet-stream;\n" .
								" name=\"{$backup['filename']}\"\n" .
								"Content-Disposition: attachment;\n" .
								" filename=\"{$backup['filename']}\"\n" .
								"Content-Transfer-Encoding: base64\n\n" .
								$file_data."\n\n--{$mime_boundary}--\n";
		$bMailSent = mail($backup_email, $mail_subject, $mail_message, $mail_header);
		
		if(!$bMailSent) echo "Problème lors de l'envoie du mail.<br />";
		else
		{
		  /* delete database file gzip */
		  $bDelete = unlink($backup['path']."/".$backup['filename']);
		  if(!$bDelete) echo "Problème lors de la suppression du fichier database gzip : ".$backup['filename'].".<br />";
		  echo "Sauvegarde de la base de données effectuée.";
		}
		return;
	}
		

	// -----------------------------------------------------------------------------------------------------------
	// ---------------------------------------- Méthodes privées -------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------


	### Function: Format Bytes Into KB/MB
	private function format_size($rawSize) {
		if($rawSize / 1073741824 > 1) 
			return round($rawSize/1048576, 1) . ' GiB';
		else if ($rawSize / 1048576 > 1)
			return round($rawSize/1048576, 1) . ' MiB';
		else if ($rawSize / 1024 > 1)
			return round($rawSize/1024, 1) . ' KiB';
		else
			return round($rawSize, 1) . ' bytes';
	}


	// -----------------------------------------------------------------------------------------------------------
	// ---------------------------------------- Divers -----------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------


 	/**
	* @brief Destructeur de la classe
	* Utilisé pour enregistrer des messages pour le debogage, fermer les fichier ouverts en écriture ou en lecture, réaliser des opérations
	* de nettoyage des objets utilisés...
	*
	* @param 
	* @return 
	*/
	public function __destruct() 
	{
 
 	}
	
	
	
	// ---------------------------------------- __toString() ----------------------------------------------------	
	/**
	 * @brief Détermine comment la classe doit réagir lorsqu'elle est convertie en chaîne de caractères.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la représentation de l'objet sous forme de chaîne.
	 */	
	public function __toString() 
	{
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les propriétés de la classe et les renvoie	
		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}
}

?>